unit remain;

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls, inifiles, new,
  Forms, Dialogs, StdCtrls, Buttons, ExtCtrls, Menus, ComCtrls, ClipBrd,
  ToolWin, ActnList, ImgList, XPMenu, spalsh, fonct, config, registry;

type
  TMainForm = class(TForm)
    MainMenu: TMainMenu;
    FileNewItem: TMenuItem;
    FileOpenItem: TMenuItem;
    FileSaveItem: TMenuItem;
    FileSaveAsItem: TMenuItem;
    FilePrintItem: TMenuItem;
    FileExitItem: TMenuItem;
    EditUndoItem: TMenuItem;
    EditCutItem: TMenuItem;
    EditCopyItem: TMenuItem;
    EditPasteItem: TMenuItem;
    OpenDialog: TOpenDialog;
    SaveDialog: TSaveDialog;
    PrintDialog: TPrintDialog;
    Ruler: TPanel;
    FontDialog1: TFontDialog;
    FirstInd: TLabel;
    LeftInd: TLabel;
    RulerLine: TBevel;
    RightInd: TLabel;
    N5: TMenuItem;
    miEditFont: TMenuItem;
    Editor: TRichEdit;
    StatusBar: TStatusBar;
    StandardToolBar: TToolBar;
    OpenButton: TToolButton;
    SaveButton: TToolButton;
    PrintButton: TToolButton;
    ToolButton5: TToolButton;
    UndoButton: TToolButton;
    CutButton: TToolButton;
    CopyButton: TToolButton;
    PasteButton: TToolButton;
    ToolButton10: TToolButton;
    FontName: TComboBox;
    FontSize: TEdit;
    ToolButton11: TToolButton;
    UpDown1: TUpDown;
    BoldButton: TToolButton;
    ItalicButton: TToolButton;
    UnderlineButton: TToolButton;
    ToolButton16: TToolButton;
    LeftAlign: TToolButton;
    CenterAlign: TToolButton;
    RightAlign: TToolButton;
    ToolButton20: TToolButton;
    BulletsButton: TToolButton;
    ToolbarImages: TImageList;
    ActionList1: TActionList;
    FileNewCmd: TAction;
    FileOpenCmd: TAction;
    FileSaveCmd: TAction;
    FilePrintCmd: TAction;
    FileExitCmd: TAction;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    Bevel1: TBevel;
    EditCutCmd: TAction;
    EditCopyCmd: TAction;
    EditPasteCmd: TAction;
    EditUndoCmd: TAction;
    EditFontCmd: TAction;
    FileSaveAsCmd: TAction;
    Panel1: TPanel;
    SpeedButton2: TSpeedButton;
    SpeedButton1: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    SpeedButton6: TSpeedButton;
    Bevel2: TBevel;
    Bevel3: TBevel;
    SpeedButton7: TSpeedButton;
    SpeedButton8: TSpeedButton;
    Bevel4: TBevel;
    SpeedButton9: TSpeedButton;
    SpeedButton10: TSpeedButton;
    SpeedButton11: TSpeedButton;
    SpeedButton12: TSpeedButton;
    Timer1: TTimer;
    SpeedButton13: TSpeedButton;
    SpeedButton14: TSpeedButton;
    SpeedButton15: TSpeedButton;
    SpeedButton16: TSpeedButton;
    SpeedButton17: TSpeedButton;
    SpeedButton18: TSpeedButton;
    Label1: TLabel;
    Bevel5: TBevel;
    Bevel6: TBevel;
    Shape1: TShape;
    Label2: TLabel;
    XPMenu1: TXPMenu;
    Timer2: TTimer;
    N3: TMenuItem;
    Apropos1: TMenuItem;
    Slctionnertout1: TMenuItem;
    ColorDialog1: TColorDialog;
    fontcolor: TPanel;
    ToolButton3: TToolButton;
    Options1: TMenuItem;
    Coloration1: TMenuItem;
    Panel2: TPanel;
    Panel3: TPanel;
    Image1: TImage;
    Panel4: TPanel;
    Panel5: TPanel;
    Panel6: TPanel;
    SpeedButton19: TSpeedButton;
    SpeedButton20: TSpeedButton;
    N6: TMenuItem;
    Afficherlaide1: TMenuItem;
    Timer3: TTimer;
    Findeligneauto1: TMenuItem;
    memo1: TRichEdit;
    SpeedButton21: TSpeedButton;

    procedure SelectionChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ShowHint(Sender: TObject);
    procedure FileNew(Sender: TObject);
    procedure FileOpen(Sender: TObject);
    procedure FileSave(Sender: TObject);
    procedure FileSaveAs(Sender: TObject);
    procedure FilePrint(Sender: TObject);
    procedure FileExit(Sender: TObject);
    procedure EditUndo(Sender: TObject);
    procedure EditCut(Sender: TObject);
    procedure EditCopy(Sender: TObject);
    procedure EditPaste(Sender: TObject);
    procedure SelectFont(Sender: TObject);
    procedure RulerResize(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure BoldButtonClick(Sender: TObject);
    procedure ItalicButtonClick(Sender: TObject);
    procedure FontSizeChange(Sender: TObject);
    procedure AlignButtonClick(Sender: TObject);
    procedure FontNameChange(Sender: TObject);
    procedure UnderlineButtonClick(Sender: TObject);
    procedure BulletsButtonClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure RulerItemMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure RulerItemMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FirstIndMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure LeftIndMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure RightIndMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormShow(Sender: TObject);
    procedure RichEditChange(Sender: TObject);
    procedure SwitchLanguage(Sender: TObject);
    procedure ActionList2Update(Action: TBasicAction;
      var Handled: Boolean);
    procedure SpeedButton2Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure SpeedButton6Click(Sender: TObject);
    procedure SpeedButton11Click(Sender: TObject);
    procedure SpeedButton9Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton10Click(Sender: TObject);
    procedure SpeedButton13MouseMove(Sender: TObject; Shift: TShiftState;
      X, Y: Integer);
    procedure Panel1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure SpeedButton14MouseMove(Sender: TObject; Shift: TShiftState;
      X, Y: Integer);
    procedure SpeedButton15MouseMove(Sender: TObject; Shift: TShiftState;
      X, Y: Integer);
    procedure SpeedButton16MouseMove(Sender: TObject; Shift: TShiftState;
      X, Y: Integer);
    procedure SpeedButton17Click(Sender: TObject);
    procedure SpeedButton18MouseMove(Sender: TObject; Shift: TShiftState;
      X, Y: Integer);
    procedure SpeedButton17MouseMove(Sender: TObject; Shift: TShiftState;
      X, Y: Integer);
    procedure SpeedButton13Click(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
    procedure SpeedButton12Click(Sender: TObject);
    procedure SpeedButton8Click(Sender: TObject);
    procedure SpeedButton7Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
    procedure Apropos1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Slctionnertout1Click(Sender: TObject);
    procedure fontcolorClick(Sender: TObject);
    procedure Coloration1Click(Sender: TObject);
    procedure EditorKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure SpeedButton9MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Memo1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Afficherlaide1Click(Sender: TObject);
    procedure Timer3Timer(Sender: TObject);
    procedure Findeligneauto1Click(Sender: TObject);
    procedure PerformFileOpen(const AFileName: string);
    procedure EditorKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure EditorMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SpeedButton21Click(Sender: TObject);
  private
    FFileName: string;
    FUpdating: Boolean;
    FDragOfs: Integer;
    FDragging: Boolean;
    function CurrText: TTextAttributes;
    procedure GetFontNames;
    procedure SetFileName(const FileName: String);
    procedure CheckFileSave;
    procedure SetupRuler;
    procedure SetEditRect;
    procedure UpdateCursorPos;
    procedure WMDropFiles(var Msg: TWMDropFiles); message WM_DROPFILES;
    procedure SetModified(Value: Boolean);
  end;

var
  MainForm: TMainForm;
  fonction, comment, param1, param2, param3 : string;
  COMMENTCOLOR, NUMCOLOR, STRINGCOLOR, VARCOLOR, KEYWORDCOLOR : Tcolor;
  keyword, keywords: TstringList;
  AppDir, nomduprogramme, description, commentaire, programmeurs : string;
  choix : integer;
  movemouse: Tpoint;


implementation

uses RichEdit, ShellAPI, ReInit;

resourcestring
  sSaveChanges = 'Enregistrer les modification pour le fichier'+#13#10+'%s ?';
  sOverWrite = 'OK pour ecraser le fichier %s';
  sUntitled = 'Sans Nom';
  sModified = 'Modifi';
  sColRowInfo = 'Ligne: %3d   Colonne: %3d';
  ApplicationTitle = 'WriteAlgo -  Copyright Pierre MOATI';

const
  RulerAdj = 4/3;
  GutterWid = 6;

{$R *.dfm}

function HelpAtCursor(i:integer) : string;
begin
    with MainForm do
    BEGIN
    case i of
    //CAS A FAIRE : 4 <Const>, 12<FONCTION>, 14<FPROGRAM>


  30:begin     //SAISIR
       memo1.Clear;
       memo1.SelAttributes.Color:=clBLACK;
       memo1.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
       memo1.seltext:='Saisir';
       memo1.SelAttributes.Color:=VARCOLOR;
       memo1.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
       memo1.seltext:=' variable';
       end;


     29:begin     //AFFICHER
       memo1.Clear;
       memo1.SelAttributes.Color:=clBLACK;
       memo1.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
       memo1.seltext:='Afficher';
       memo1.SelAttributes.Color:=STRINGCOLOR;
       memo1.SelAttributes.Style:=CurrText.Style-[fsbold]-[fsitalic]-[fsunderline];
       memo1.seltext:=' "Bonjour "';
       memo1.SelAttributes.Color:=clBLACK;
       memo1.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
       memo1.seltext:=',';
       memo1.SelAttributes.Color:=VARCOLOR;
       memo1.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
       memo1.seltext:='nom';
       memo1.SelAttributes.Color:=clBLACK;
       memo1.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
       memo1.seltext:=',';
       memo1.SelAttributes.Color:=STRINGCOLOR;
       memo1.SelAttributes.Style:=CurrText.Style-[fsbold]-[fsitalic]-[fsunderline];
       memo1.seltext:='" Vous avez "';
       memo1.SelAttributes.Color:=clBLACK;
       memo1.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
       memo1.seltext:=',';
       memo1.SelAttributes.Color:=VARCOLOR;
       memo1.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
       memo1.seltext:='age';
       memo1.SelAttributes.Color:=clBLACK;
       memo1.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
       memo1.seltext:=',';
       memo1.SelAttributes.Color:=STRINGCOLOR;
       memo1.SelAttributes.Style:=CurrText.Style-[fsbold]-[fsitalic]-[fsunderline];
       memo1.seltext:='" ans !"';
       end;

   31:begin     //IMPRIMER
       memo1.Clear;
       memo1.SelAttributes.Color:=clBLACK;
       memo1.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
       memo1.seltext:='Imprimer';
       memo1.SelAttributes.Color:=STRINGCOLOR;
       memo1.SelAttributes.Style:=CurrText.Style-[fsbold]-[fsitalic]-[fsunderline];
       memo1.seltext:=' "Chane de caractre n"';
       memo1.SelAttributes.Color:=clBLACK;
       memo1.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
       memo1.seltext:=',';
       memo1.SelAttributes.Color:=VARCOLOR;
       memo1.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
       memo1.seltext:='i';
        end;

    0,11 :begin     //REPETER, JUSQU'A
       memo1.Clear;
       memo1.SelAttributes.Color:=clBLACK;
       memo1.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
       memo1.seltext:='REPETER '+#13#10;
       memo1.SelAttributes.Color:=clBLACK;
       memo1.SelAttributes.Style:=CurrText.Style-[fsbold]+[fsitalic]-[fsunderline];
       memo1.seltext:='   Instructions'+#13#10;
       memo1.SelAttributes.Color:=clBLACK;
       memo1.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
       memo1.seltext:='JUSQU''A';
       memo1.SelAttributes.Color:=clBLACK;
       memo1.SelAttributes.Style:=CurrText.Style-[fsbold]+[fsitalic]-[fsunderline];
       memo1.seltext:=' Condition';
        end;
    1,8,13,17 :begin     //POUR, JQA, FPOUR, FINPOUR
       memo1.Clear;
       memo1.SelAttributes.Color:=clBLACK;
       memo1.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
       memo1.seltext:='POUR ';
       memo1.SelAttributes.Color:=clBLACK;
       memo1.SelAttributes.Style:=CurrText.Style-[fsbold]-[fsitalic]-[fsunderline];
       memo1.SelAttributes.Color:=VARCOLOR;
       memo1.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
       memo1.seltext:='var1';
       memo1.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
       memo1.SelAttributes.Color:=clblack;
       memo1.seltext:='';
       memo1.SelStart:=memo1.SelStart-1;
       memo1.SelLength:=1;
       memo1.SelAttributes.Name:='Symbol';
       memo1.SelStart:=memo1.SelStart+2;
       memo1.SelAttributes.Name:='Comic Sans MS';
       memo1.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
       memo1.SelAttributes.Color:=NUMCOLOR;
       memo1.seltext:='0';
       memo1.SelAttributes.Color:=clBLACK;
       memo1.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
       memo1.seltext:=' JQA ';
       memo1.SelAttributes.Color:=VARCOLOR;
       memo1.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
       memo1.seltext:=' n '+#13#10;
       memo1.SelAttributes.Color:=clBLACK;
       memo1.SelAttributes.Style:=CurrText.Style-[fsbold]+[fsitalic]-[fsunderline];
       memo1.seltext:='   Instructions '+#13#10;
       memo1.SelAttributes.Color:=clBLACK;
       memo1.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
       memo1.seltext:='FPOUR';
       end;
    2 :begin     // PAS (DE...)
       memo1.Clear;
       memo1.SelAttributes.Color:=clBLACK;
       memo1.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
       memo1.seltext:='POUR ';
       memo1.SelAttributes.Color:=clBLACK;
       memo1.SelAttributes.Style:=CurrText.Style-[fsbold]-[fsitalic]-[fsunderline];
       memo1.SelAttributes.Color:=VARCOLOR;
       memo1.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
       memo1.seltext:='var1';
       memo1.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
       memo1.SelAttributes.Color:=clblack;
       memo1.seltext:='';
       memo1.SelStart:=memo1.SelStart-1;
       memo1.SelLength:=1;
       memo1.SelAttributes.Name:='Symbol';
       memo1.SelStart:=memo1.SelStart+2;
       memo1.SelAttributes.Name:='Comic Sans MS';
       memo1.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
       memo1.SelAttributes.Color:=NUMCOLOR;
       memo1.seltext:='0';
       memo1.SelAttributes.Color:=clBLACK;
       memo1.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
       memo1.seltext:=' JQA ';
       memo1.SelAttributes.Color:=NUMCOLOR;
       memo1.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
       memo1.seltext:='6';
       memo1.SelAttributes.Color:=clBLACK;
       memo1.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
       memo1.seltext:=' PAS DE ';
       memo1.SelAttributes.Color:=NUMCOLOR;
       memo1.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
       memo1.seltext:='2 '+#13#10;
       memo1.SelAttributes.Color:=clBLACK;
       memo1.SelAttributes.Style:=CurrText.Style-[fsbold]+[fsitalic]-[fsunderline];
       memo1.seltext:='   Instructions '+#13#10;
       memo1.SelAttributes.Color:=clBLACK;
       memo1.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
       memo1.seltext:='FPOUR';
       end;
    4 :begin          //CONST
       end;
   5,28,27 :begin     //DEBUT, FIN, DBUT
       memo1.Clear;
       memo1.SelAttributes.Color:=clBlack;
       memo1.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
       memo1.seltext:='DBUT'+#13#10;
       memo1.SelAttributes.Style:=CurrText.Style-[fsbold]+[fsitalic]-[fsunderline];
       memo1.seltext:='   Instructions '+#13#10;
       memo1.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
       memo1.seltext:='FIN';
       end;
 6,24,18 :begin     //SUIVANTE...FAIRE...FINSUIVANT
       memo1.Clear;
       memo1.SelAttributes.Color:=clBlack;
       memo1.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
       memo1.seltext:='SUIVANT';
       memo1.SelAttributes.Color:=VARCOLOR;
       memo1.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
       memo1.seltext:=' var1';
       memo1.SelAttributes.Color:=clBlack;
       memo1.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
       memo1.seltext:=' FAIRE'+#13#10;
       memo1.SelAttributes.Color:=NUMCOLOR;
       memo1.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
       memo1.seltext:='   1';
       memo1.SelAttributes.Color:=clBlack;
       memo1.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
       memo1.seltext:=' :';
       memo1.SelAttributes.Color:=clBlack;
       memo1.SelAttributes.Style:=CurrText.Style-[fsbold]+[fsitalic]-[fsunderline];
       memo1.seltext:='Instructions'+#13#10;
       memo1.SelAttributes.Color:=clBlack;
       memo1.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
       memo1.seltext:='FINSUIVANT'+#13#10;
       end;
    7 :begin     //FFONCTION
       end;
    10,25,16:begin //TANTQUE, FINTANTQUE, FTQ
       memo1.Clear;
       memo1.SelAttributes.Color:=clBlack;
       memo1.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
       memo1.seltext:='TANTQUE';
       memo1.SelAttributes.Color:=VARCOLOR;
       memo1.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
       memo1.seltext:=' <condition>'+#13#10;
              memo1.SelAttributes.Color:=clBlack;
       memo1.SelAttributes.Style:=CurrText.Style-[fsbold]+[fsitalic]-[fsunderline];
       memo1.seltext:='   Instructions '+#13#10;
       memo1.SelAttributes.Color:=clBlack;
       memo1.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
       memo1.seltext:=' FTQ';
       end;
    12:begin     //FONCTION
       end;
    14:begin     //FPROGRAMME
       end;
    19:begin     // OU
       memo1.Clear;
       memo1.SelAttributes.Color:=clBLACK;
       memo1.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
       memo1.seltext:='Operateur : OU '+#13#10;
       memo1.SelAttributes.Color:=clBLACK;
       memo1.SelAttributes.Style:=CurrText.Style-[fsbold]-[fsitalic]-[fsunderline];
       memo1.seltext:='Permet de combiner plusieurs tests'+#13#10;
       memo1.SelAttributes.Color:=clBLACK;
       memo1.SelAttributes.Style:=CurrText.Style-[fsbold]-[fsitalic]-[fsunderline];
       memo1.seltext:='ex : ';
       memo1.SelAttributes.Color:=clBLACK;
       memo1.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
       memo1.seltext:='SI (';
       memo1.SelAttributes.Color:=VARCOLOR;
       memo1.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
       memo1.seltext:='var1';
       memo1.SelAttributes.Color:=clBlack;
       memo1.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
       memo1.seltext:='=';
       memo1.SelAttributes.Color:=clblue;
       memo1.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
       memo1.seltext:='10';
       memo1.SelAttributes.Color:=clBLACK;
       memo1.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
       memo1.seltext:=' OU ';
       memo1.SelAttributes.Color:=VARCOLOR;
       memo1.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
       memo1.seltext:='var2';
       memo1.SelAttributes.Color:=clBlack;
       memo1.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
       memo1.seltext:='=';
       memo1.SelAttributes.Color:=NUMCOLOR;
       memo1.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
       memo1.seltext:='20';
       memo1.SelAttributes.Color:=clBLACK;
       memo1.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
       memo1.seltext:=') ALORS...';
       end;
    20:begin     //PROGRAMME
       memo1.Clear;
       memo1.SelAttributes.Color:=clBLACK;
       memo1.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
       memo1.seltext:='PROGRAMME ';
       memo1.SelAttributes.Color:=clBLACK;
       memo1.SelAttributes.Style:=CurrText.Style-[fsbold]-[fsitalic]-[fsunderline];
       memo1.seltext:='<Nom_du_programme>';
       end;
    21:begin     // ET
       memo1.Clear;
       memo1.SelAttributes.Color:=clBLACK;
       memo1.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
       memo1.seltext:='Operateur : ET '+#13#10;
       memo1.SelAttributes.Color:=clBLACK;
       memo1.SelAttributes.Style:=CurrText.Style-[fsbold]-[fsitalic]-[fsunderline];
       memo1.seltext:='Permet de combiner plusieurs tests'+#13#10;
       memo1.SelAttributes.Color:=clBLACK;
       memo1.SelAttributes.Style:=CurrText.Style-[fsbold]-[fsitalic]-[fsunderline];
       memo1.seltext:='ex : ';
       memo1.SelAttributes.Color:=clBLACK;
       memo1.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
       memo1.seltext:='SI (';
       memo1.SelAttributes.Color:=VARCOLOR;
       memo1.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
       memo1.seltext:='var1';
       memo1.SelAttributes.Color:=clBlack;
       memo1.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
       memo1.seltext:='=';
       memo1.SelAttributes.Color:=clblue;
       memo1.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
       memo1.seltext:='10';
       memo1.SelAttributes.Color:=clBLACK;
       memo1.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
       memo1.seltext:=' ET ';
       memo1.SelAttributes.Color:=VARCOLOR;
       memo1.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
       memo1.seltext:='var2';
       memo1.SelAttributes.Color:=clBlack;
       memo1.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
       memo1.seltext:='=';
       memo1.SelAttributes.Color:=NUMCOLOR;
       memo1.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
       memo1.seltext:='20';
       memo1.SelAttributes.Color:=clBLACK;
       memo1.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
       memo1.seltext:=') ALORS...';
       end;

3,9, 15,22,23:begin    //SI , ALORS, FINSI, FSI, SINON
       memo1.Clear;
       memo1.SelAttributes.Color:=clBlack;
       memo1.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
       memo1.seltext:='SI (';
       memo1.SelAttributes.Color:=VARCOLOR;
       memo1.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
       memo1.seltext:='var1';
       memo1.SelAttributes.Color:=clBlack;
       memo1.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
       memo1.seltext:='=';
       memo1.SelAttributes.Color:=clblue;
       memo1.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
       memo1.seltext:='10';
       memo1.SelAttributes.Color:=clBLACK;
       memo1.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
       memo1.seltext:=') ALORS'+#13#10;
       memo1.SelAttributes.Color:=clBLACK;
       memo1.SelAttributes.Style:=CurrText.Style-[fsbold]+[fsitalic]-[fsunderline];
       memo1.seltext:='Instructions';
       memo1.SelAttributes.Color:=clBLACK;
       memo1.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
       memo1.seltext:=' SINON';
       memo1.SelAttributes.Color:=clBLACK;
       memo1.SelAttributes.Style:=CurrText.Style-[fsbold]+[fsitalic]-[fsunderline];
       memo1.seltext:=' Instructions'+#13#10;
       memo1.SelAttributes.Color:=clBLACK;
       memo1.SelAttributes.Style:=CurrText.Style+[fsbold]+[fsitalic]-[fsunderline];
       memo1.seltext:='FINSI';
       end;

       230:begin    //SI ...PAS DE SINON !!! cas special !
       memo1.Clear;
       memo1.SelAttributes.Color:=clBlack;
       memo1.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
       memo1.seltext:='SI (';
       memo1.SelAttributes.Color:=VARCOLOR;
       memo1.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
       memo1.seltext:='var1';
       memo1.SelAttributes.Color:=clBlack;
       memo1.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
       memo1.seltext:='=';
       memo1.SelAttributes.Color:=clblue;
       memo1.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
       memo1.seltext:='10';
       memo1.SelAttributes.Color:=clBLACK;
       memo1.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
       memo1.seltext:=') ALORS'+#13#10;
       memo1.SelAttributes.Color:=clBLACK;
       memo1.SelAttributes.Style:=CurrText.Style-[fsbold]+[fsitalic]-[fsunderline];
       memo1.seltext:='Instructions'+#13#10;
       memo1.SelAttributes.Color:=clBLACK;
       memo1.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
       memo1.SelAttributes.Color:=clBLACK;
       memo1.SelAttributes.Style:=CurrText.Style+[fsbold]+[fsitalic]-[fsunderline];
       memo1.seltext:='FINSI';
       end;


    26:begin     //VAR
       memo1.Clear;
       memo1.SelAttributes.Color:=clBLACK;
       memo1.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
       memo1.seltext:='VAR ';
       memo1.SelAttributes.Color:=clred;
       memo1.seltext:='<var1>';
       memo1.SelAttributes.Color:=clblack;
       memo1.seltext:=', ';
       memo1.SelAttributes.Color:=clred;
       memo1.seltext:='<var2>';
       memo1.SelAttributes.Color:=clblack;
       memo1.seltext:=', ';
       memo1.SelAttributes.Color:=clred;
       memo1.seltext:='<var3>';
       memo1.SelAttributes.Color:=clblack;
       memo1.seltext:=' : <type_de_variables>'+#13#10#10+'<type_de_variables> : entier(s), caractere(s), ...';
       end;
    end;
    EXIT;
END;
end;

function WordAtCursor: string;
var
  Range: TCharRange;
  i:integer;
  test : string;
begin
  if mainform.editor.Text='' then exit;
  Result := '';
  if mainform.editor.HandleAllocated then begin
    Range.cpMax := mainform.editor.SelStart+1;
    if Range.cpMax = 0 then Range.cpMin := 0
    else if SendMessage(mainform.editor.Handle, EM_FINDWORDBREAK, WB_ISDELIMITER, Range.cpMax) <> 0 then
      Range.cpMin := SendMessage(mainform.editor.Handle, EM_FINDWORDBREAK, WB_MOVEWORDLEFT, Range.cpMax)
    else
      Range.cpMin := SendMessage(mainform.editor.Handle, EM_FINDWORDBREAK, WB_LEFT, Range.cpMax);
    while SendMessage(mainform.editor.Handle, EM_FINDWORDBREAK, WB_ISDELIMITER, Range.cpMin) <> 0 do
      Inc(Range.cpMin);
    Range.cpMax := SendMessage(mainform.editor.Handle, EM_FINDWORDBREAK, WB_RIGHTBREAK, Range.cpMax);
    END;
    test:='';
    For i:=Range.cpMin to Range.cpMax do
    BEGIN
       case Ord(MainForm.Editor.Text[i]) of
       0 :begin end;
       32:begin end;
       13:begin end;
       10:begin end;
       else
       begin
       Result:=Result+mainform.Editor.Text[i];
       end;
       end;
    END;
    Result:=Result+' : '+inttostr(length(Result));
  end;

procedure TMainForm.SelectionChange(Sender: TObject);
begin
  with Editor.Paragraph do
  try
    FUpdating := True;
    FirstInd.Left := Trunc(FirstIndent*RulerAdj)-4+GutterWid;
    LeftInd.Left := Trunc((LeftIndent+FirstIndent)*RulerAdj)-4+GutterWid;
    RightInd.Left := Ruler.ClientWidth-6-Trunc((RightIndent+GutterWid)*RulerAdj);
    BoldButton.Down := fsBold in Editor.SelAttributes.Style;
    ItalicButton.Down := fsItalic in Editor.SelAttributes.Style;
    UnderlineButton.Down := fsUnderline in Editor.SelAttributes.Style;
    BulletsButton.Down := Boolean(Numbering);
    FontSize.Text := IntToStr(Editor.SelAttributes.Size);
    FontName.Text := Editor.SelAttributes.Name;
    fontcolor.Color:=Editor.SelAttributes.Color;
    case Ord(Alignment) of
      0: LeftAlign.Down := True;
      1: RightAlign.Down := True;
      2: CenterAlign.Down := True;
    end;
    UpdateCursorPos;
  finally
    FUpdating := False;
  end;
end;

function TMainForm.CurrText: TTextAttributes;
begin
  if Editor.SelLength > 0 then Result := Editor.SelAttributes
  else Result := Editor.DefAttributes;
end;

function EnumFontsProc(var LogFont: TLogFont; var TextMetric: TTextMetric;
  FontType: Integer; Data: Pointer): Integer; stdcall;
begin
  TStrings(Data).Add(LogFont.lfFaceName);
  Result := 1;
end;

procedure TMainForm.GetFontNames;
var
  DC: HDC;
  i : integer;
begin
  DC := GetDC(0);
  EnumFonts(DC, nil, @EnumFontsProc, Pointer(FontName.Items));
  ReleaseDC(0, DC);
  FontName.Sorted := True;
end;

procedure TMainForm.SetFileName(const FileName: String);
begin
  FFileName := FileName;
  Caption := Format('%s - %s', [ExtractFileName(FileName), ApplicationTitle]);
end;

procedure TMainForm.CheckFileSave;
var
  SaveResp: Integer;
begin
  if not Editor.Modified then Exit;
  SaveResp := MessageDlg(Format(sSaveChanges, [FFileName]),
    mtConfirmation, mbYesNoCancel, 0);
  case SaveResp of
    idYes: FileSave(Self);
    idNo: {Nothing};
    idCancel: Abort;
  end;
end;

procedure TMainForm.SetupRuler;
var
  I: Integer;
  S: String;
begin
  SetLength(S, 201);
  I := 1;
  while I < 200 do
  begin
    S[I] := #9;
    S[I+1] := '|';
    Inc(I, 2);
  end;
  Ruler.Caption := S;
end;

procedure TMainForm.SetEditRect;
var
  R: TRect;
begin
  with Editor do
  begin
    R := Rect(GutterWid, 0, ClientWidth-GutterWid, ClientHeight);
    SendMessage(Handle, EM_SETRECT, 0, Longint(@R));
  end;
end;

{ Event Handlers }

procedure TMainForm.FormCreate(Sender: TObject);
var regi : TRegistry;
begin
  nomduprogramme:='<Nom_du_programme>';
  AppDir:=ExtractFilePath(Application.ExeName);
  if AppDir[length(AppDir)]<>'\' then AppDir:=AppDir+'\';
  regi:=TRegistry.Create;
  regi.RootKey:=HKEY_LOCAL_MACHINE;
  regi.OpenKey('Software\MOATI\WriteAlgo',true);

  if regi.ReadString('COMMENTCOLOR')<>'' then COMMENTCOLOR:=StringToColor(regi.ReadString('COMMENTCOLOR')) else COMMENTCOLOR:=clteal;
  if regi.ReadString('NUMCOLOR')<>'' then NUMCOLOR:=StringToColor(regi.ReadString('NUMCOLOR')) else NUMCOLOR:=clblue;
  if regi.ReadString('STRINGCOLOR')<>'' then STRINGCOLOR:=StringToColor(regi.ReadString('STRINGCOLOR')) else STRINGCOLOR:=clnavy;
  if regi.ReadString('VARCOLOR')<>'' then VARCOLOR:=StringToColor(regi.ReadString('VARCOLOR')) else VARCOLOR:=clred;
  if regi.ReadString('KEYWORDCOLOR')<>'' then KEYWORDCOLOR:=StringToColor(regi.ReadString('KEYWORDCOLOR')) else KEYWORDCOLOR:=clblack;

  if regi.ReadString('ENDOFLINEAUTO')='false' then Findeligneauto1.Checked:=false;

  if regi.ReadString('ENABLEHELP')='false' then   //Si on a demand de cacher le panneau d'aide rapide
  begin
  panel2.Visible:=false;                          //alors on le cache,
  Afficherlaide1.Checked:=false;                  //et on decoche le menu !
  end;
  regi.CloseKey;
  regi.Free;

  Application.OnHint := ShowHint;
  OpenDialog.InitialDir := ExtractFilePath(ParamStr(0));
  SaveDialog.InitialDir := OpenDialog.InitialDir;
  SetFileName(sUntitled);
  GetFontNames;
  SetupRuler;
  SelectionChange(Self);

  CurrText.Name := DefFontData.Name;
  CurrText.Size := -MulDiv(DefFontData.Height, 72, Screen.PixelsPerInch);

end;

procedure TMainForm.ShowHint(Sender: TObject);
begin
  if Length(Application.Hint) > 0 then
  begin
    StatusBar.SimplePanel := True;
    StatusBar.SimpleText := Application.Hint;
  end
  else StatusBar.SimplePanel := False;
end;

procedure TMainForm.FileNew(Sender: TObject);
var confirm : integer;
begin
  CheckFileSave;
with Tnouveau.Create(Self) do
try
  confirm:=ShowModal;
finally
  Free;
end;
if (confirm=mrok) then
BEGIN
  SetFileName(sUntitled);
  Editor.Lines.Clear;
  Timer1.Enabled:=true;
  Editor.Modified := False;
  SetModified(False);
END;
end;

procedure TMainForm.PerformFileOpen(const AFileName: string);
begin
  Editor.Lines.LoadFromFile(AFileName);
  SetFileName(AFileName);
  Editor.SetFocus;
  Editor.Modified := False;
  SetModified(False);
end;

procedure TMainForm.FileOpen(Sender: TObject);
begin
  CheckFileSave;
  if OpenDialog.Execute then
  begin
    PerformFileOpen(OpenDialog.FileName);
    Editor.ReadOnly := ofReadOnly in OpenDialog.Options;
  end;
end;

procedure TMainForm.FileSave(Sender: TObject);
begin
  if FFileName = sUntitled then
    FileSaveAs(Sender)
  else
  begin
    Editor.Lines.SaveToFile(FFileName);
    Editor.Modified := False;
    SetModified(False);
  end;
end;

procedure TMainForm.FileSaveAs(Sender: TObject);
begin
  if SaveDialog.Execute then
  begin
  ChangeFileExt(SaveDialog.FileName,'.RTF');
    if FileExists(SaveDialog.FileName) then
      if MessageDlg(Format(sOverWrite, [SaveDialog.FileName]),
        mtConfirmation, mbYesNoCancel, 0) <> idYes then Exit;
    Editor.Lines.SaveToFile(SaveDialog.FileName);
    SetFileName(SaveDialog.FileName);
    Editor.Modified := False;
    SetModified(False);
  end;
end;

procedure TMainForm.FilePrint(Sender: TObject);
begin
  if PrintDialog.Execute then
    Editor.Print(FFileName);
end;

procedure TMainForm.FileExit(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.EditUndo(Sender: TObject);
begin
  with Editor do
    if HandleAllocated then SendMessage(Handle, EM_UNDO, 0, 0);
end;

procedure TMainForm.EditCut(Sender: TObject);
begin
  Editor.CutToClipboard;
end;

procedure TMainForm.EditCopy(Sender: TObject);
begin
  Editor.CopyToClipboard;
end;

procedure TMainForm.EditPaste(Sender: TObject);
begin
  Editor.PasteFromClipboard;
end;

procedure TMainForm.SelectFont(Sender: TObject);
begin
  FontDialog1.Font.Assign(Editor.SelAttributes);
  if FontDialog1.Execute then
    CurrText.Assign(FontDialog1.Font);
  SelectionChange(Self);
  Editor.SetFocus;
end;

procedure TMainForm.RulerResize(Sender: TObject);
begin
  RulerLine.Width := Ruler.ClientWidth - (RulerLine.Left*2);
end;

procedure TMainForm.FormResize(Sender: TObject);
begin
  SetEditRect;
  SelectionChange(Sender);
end;

procedure TMainForm.FormPaint(Sender: TObject);
begin
  SetEditRect;
end;

procedure TMainForm.BoldButtonClick(Sender: TObject);
begin
  if FUpdating then Exit;
  if BoldButton.Down then
  Editor.SelAttributes.Style := Editor.SelAttributes.Style + [fsBold]
  else
  Editor.SelAttributes.Style := Editor.SelAttributes.Style - [fsBold]
end;

procedure TMainForm.ItalicButtonClick(Sender: TObject);
begin
  if FUpdating then Exit;
  if ItalicButton.Down then
  Editor.SelAttributes.Style := Editor.SelAttributes.Style + [fsItalic]
  else
  Editor.SelAttributes.Style := Editor.SelAttributes.Style - [fsItalic];
end;

procedure TMainForm.FontSizeChange(Sender: TObject);
begin
  if FUpdating then Exit;
  CurrText.Size := StrToInt(FontSize.Text);
end;

procedure TMainForm.AlignButtonClick(Sender: TObject);
begin
  if FUpdating then Exit;
  Editor.Paragraph.Alignment := TAlignment(TControl(Sender).Tag);
end;

procedure TMainForm.FontNameChange(Sender: TObject);
begin
  if FUpdating then Exit;
  CurrText.Name := FontName.Items[FontName.ItemIndex];
end;

procedure TMainForm.UnderlineButtonClick(Sender: TObject);
begin
  if FUpdating then Exit;
  if UnderlineButton.Down then
  Editor.SelAttributes.Style := Editor.SelAttributes.Style + [fsUnderline]
  else
  Editor.SelAttributes.Style := Editor.SelAttributes.Style - [fsUnderline];
end;

procedure TMainForm.BulletsButtonClick(Sender: TObject);
begin
  if FUpdating then Exit;
  Editor.Paragraph.Numbering := TNumberingStyle(BulletsButton.Down);
end;

procedure TMainForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  try
    CheckFileSave;
  except
    CanClose := False;
  end;
end;

{ Ruler Indent Dragging }

procedure TMainForm.RulerItemMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  FDragOfs := (TLabel(Sender).Width div 2);
  TLabel(Sender).Left := TLabel(Sender).Left+X-FDragOfs;
  FDragging := True;
end;

procedure TMainForm.RulerItemMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
  if FDragging then
    TLabel(Sender).Left :=  TLabel(Sender).Left+X-FDragOfs
end;

procedure TMainForm.FirstIndMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  FDragging := False;
  Editor.Paragraph.FirstIndent := Trunc((FirstInd.Left+FDragOfs-GutterWid) / RulerAdj);
  LeftIndMouseUp(Sender, Button, Shift, X, Y);
end;

procedure TMainForm.LeftIndMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  FDragging := False;
  Editor.Paragraph.LeftIndent := Trunc((LeftInd.Left+FDragOfs-GutterWid) / RulerAdj)-Editor.Paragraph.FirstIndent;
  SelectionChange(Sender);
end;

procedure TMainForm.RightIndMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  FDragging := False;
  Editor.Paragraph.RightIndent := Trunc((Ruler.ClientWidth-RightInd.Left+FDragOfs-2) / RulerAdj)-2*GutterWid;
  SelectionChange(Sender);
end;

procedure TMainForm.UpdateCursorPos;
var
  CharPos: TPoint;
begin
  CharPos.Y := SendMessage(Editor.Handle, EM_EXLINEFROMCHAR, 0,
    Editor.SelStart);
  CharPos.X := (Editor.SelStart -
    SendMessage(Editor.Handle, EM_LINEINDEX, CharPos.Y, 0));
  Inc(CharPos.Y);
  Inc(CharPos.X);
  StatusBar.Panels[0].Text := Format(sColRowInfo, [CharPos.Y, CharPos.X]);
end;

procedure TMainForm.FormShow(Sender: TObject);
begin
  UpdateCursorPos;
  DragAcceptFiles(Handle, True);
  RichEditChange(nil);
  Editor.SetFocus;
  { Check if we should load a file from the command line }
  if (ParamCount > 0) and FileExists(ParamStr(1)) then
    PerformFileOpen(ParamStr(1));
end;

procedure TMainForm.WMDropFiles(var Msg: TWMDropFiles);
var
  CFileName: array[0..MAX_PATH] of Char;
begin
  try
    if DragQueryFile(Msg.Drop, 0, CFileName, MAX_PATH) > 0 then
    begin
      CheckFileSave;
      PerformFileOpen(CFileName);
      Msg.Result := 0;
    end;
  finally
    DragFinish(Msg.Drop);
  end;
end;

procedure TMainForm.RichEditChange(Sender: TObject);
begin


  SetModified(Editor.Modified);
end;

procedure TMainForm.SetModified(Value: Boolean);
begin
  if Value then StatusBar.Panels[1].Text := sModified
  else StatusBar.Panels[1].Text := '';
end;

procedure TMainForm.SwitchLanguage(Sender: TObject);
var
  Name : String;
  Size : Integer;
begin
  if LoadNewResourceModule(TComponent(Sender).Tag) <> 0 then
  begin
    Name := FontName.Text;
    Size := StrToInt(FontSize.Text);
    ReinitializeForms;
    CurrText.Name := Name;
    CurrText.Size := Size;
    SelectionChange(Self);
    FontName.SelLength := 0;

    SetupRuler;
    if Visible then Editor.SetFocus;
  end;
end;

procedure TMainForm.ActionList2Update(Action: TBasicAction;
  var Handled: Boolean);
begin
 { Update the status of the edit commands }
  EditCutCmd.Enabled := Editor.SelLength > 0;
  EditCopyCmd.Enabled := EditCutCmd.Enabled;
  if Editor.HandleAllocated then
  begin
    EditUndoCmd.Enabled := Editor.Perform(EM_CANUNDO, 0, 0) <> 0;
    EditPasteCmd.Enabled := Editor.Perform(EM_CANPASTE, 0, 0) <> 0;
  end;
end;

procedure TMainForm.SpeedButton2Click(Sender: TObject);
begin
CurrText.Name:='Lucida Console';
GetCaretPos(movemouse);
SetCursorPos(movemouse.X+MainForm.Left+Editor.left+8,movemouse.Y+MainForm.top+Editor.top+100);
HelpAtCursor(29);

Editor.SelAttributes.Color:=clblack;
Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
Editor.seltext:='Afficher ';
Editor.SelAttributes.Style:=CurrText.Style-[fsbold]-[fsitalic]-[fsunderline];
Editor.SelAttributes.Color:=STRINGCOLOR;
Editor.seltext:='" "';
Editor.SelStart:=Editor.SelStart-2;
editor.SelLength:=1;
end;

procedure TMainForm.Timer1Timer(Sender: TObject);
var i : integer;
begin
Timer1.Enabled:=false;
keywords:=TStringList.Create;
keywords.Add('REPETER');     //0
keywords.Add('POUR');        //1
keywords.Add('PAS');         //2
keywords.Add('ALORS');       //3
keywords.Add('CONST');       //4
keywords.Add('DEBUT');       //5
keywords.Add('FAIRE');       //6
keywords.Add('FFONCTION');   //7
keywords.Add('FINPOUR');     //8
keywords.Add('FINSI');       //9
keywords.Add('FINTANTQUE');  //10
keywords.Add('JUSQU''A');    //11
keywords.Add('FONCTION');    //12
keywords.Add('FPOUR');       //13
keywords.Add('FPROGRAMME');  //14
keywords.Add('FSI');         //15
keywords.Add('FTQ');         //16
keywords.Add('JQA');         //17
keywords.Add('FINSUIVANT');  //18
keywords.Add('OU');          //19
keywords.Add('PROGRAMME');   //20
keywords.Add('ET');          //21
keywords.Add('SINON');       //22
keywords.Add('SI');          //23
keywords.Add('SUIVANT');     //24
keywords.Add('TANTQUE');     //25
keywords.Add('VAR');         //26
keywords.Add('DBUT');       //27
keywords.Add('FIN');         //28
keywords.Add('AFFICHER');    //29
keywords.Add('SAISIR');      //30
keywords.Add('IMPRIMER');    //31



keyword:=TStringList.Create;
keyword.Add(' ET');
keyword.Add(' OU');
keyword.Add(' PAS DE');
//keywords.Add('FINSUIVANT'); 
//keyword.Add('ALORS');
//keyword.Add('CONST');
//keyword.Add('DEBUT');
//keyword.Add('FAIRE');
//keyword.Add('FFONCTION');
//keyword.Add(' FIN');
//keyword.Add('FINPOUR');
//keyword.Add('FINSI');
//keyword.Add('FINTANTQUE');
//keyword.Add('FONCTION');
//keyword.Add('FPOUR');
//keyword.Add('FPROGRAMME');
//keyword.Add('FSI');
//keyword.Add('FTQ');
//keyword.Add('JQA');
//keyword.Add('JUSQU''A');
//keyword.Add('POUR');
//keyword.Add('PROGRAMME');
//keyword.Add('REPETER');
//keyword.Add('SI');
//keyword.Add('SINON');
//keyword.Add('SUIVANT');
//keyword.Add('TANTQUE');
//keyword.Add('VAR');
CurrText.Size:=10;
Editor.SelAttributes.Name:='Lucida Console';
CurrText.Name:='Lucida Console';
Editor.SelAttributes.Color:=clblack;
Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
Editor.seltext:='Programme '+nomduprogramme;

if programmeurs<>'' then
BEGIN
Editor.SelAttributes.Color:=COMMENTCOLOR;
Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
Editor.seltext:=' // '+programmeurs;
END;

Editor.seltext:=#13#10;

if description<>'' then
BEGIN
Editor.SelAttributes.Color:=COMMENTCOLOR;
Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
Editor.seltext:='(* '+description+' *)'+#13#10#10;
END
else Editor.seltext:=#10;



Editor.SelAttributes.Color:=COMMENTCOLOR;
Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
Editor.seltext:='(* Dclaration des variables *)'+#13#10;

Editor.SelAttributes.Color:=clblack;
Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
Editor.seltext:='VAR ';

for i:=1 to 3 do
BEGIN
Editor.SelAttributes.Color:=VARCOLOR;
Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
Editor.seltext:='<var'+inttostr(i)+'>';

Editor.SelAttributes.Color:=clblack;
Editor.SelAttributes.Style:=CurrText.Style-[fsbold]-[fsitalic]-[fsunderline];
Editor.seltext:=', ';
END;

Editor.SelAttributes.Color:=VARCOLOR;
Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
Editor.seltext:='<...>';

Editor.SelAttributes.Color:=clblack;
Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
Editor.seltext:=' : ';

Editor.SelAttributes.Color:=clblack;
Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
Editor.seltext:='<type de variable>'+#13#10#10;

Editor.SelAttributes.Color:=clblack;
Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
Editor.seltext:='DBUT'+#13#10;

Editor.SelAttributes.Color:=COMMENTCOLOR;
Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
Editor.seltext:='(* Initialisations des variables *)'+#13#10;

Editor.SelAttributes.Color:=clblack;
Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
Editor.seltext:=#13#10#10+'FIN';

Editor.SelStart:=Editor.SelStart-5;

Editor.Modified := False;
SetModified(False);
end;

procedure TMainForm.SpeedButton6Click(Sender: TObject);
begin
CurrText.Name:='Lucida Console';
  GetCaretPos(movemouse);
  SetCursorPos(movemouse.X+MainForm.Left+Editor.left+8,movemouse.Y+MainForm.top+Editor.top+100);
  memo1.Clear;
  memo1.SelAttributes.Color:=COMMENTCOLOR;
  memo1.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
  memo1.seltext:='Commentaire : '+#13#10+'(* Commentaire sur plusieurs lignes *)'+#13#10+'// Commentaire sur une ligne';

Editor.SelAttributes.Color:=COMMENTCOLOR;
Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
Editor.seltext:='(*   *)';
Editor.SelAttributes.Color:=clblack;
Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
editor.SelStart:=editor.SelStart-4;
editor.SelLength:=1;
end;

procedure TMainForm.SpeedButton11Click(Sender: TObject);
begin
CurrText.Name:='Lucida Console';
Editor.seltext:=' ';
Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
Editor.SelAttributes.Color:=clblack;
Editor.seltext:='';
editor.SelStart:=editor.SelStart-1;
editor.SelLength:=1;
CurrText.Name:='Symbol';
editor.SelStart:=editor.SelStart+1;
Editor.seltext:='  ';
editor.SelStart:=editor.SelStart-1;
editor.SelLength:=1;
CurrText.Name:='Lucida Console';
Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
Editor.SelAttributes.Color:=VARCOLOR;
end;

procedure TMainForm.SpeedButton9Click(Sender: TObject);
var i : integer;
begin
CurrText.Name:='Lucida Console';
GetCaretPos(movemouse);
SetCursorPos(movemouse.X+MainForm.Left+Editor.left+8,movemouse.Y+MainForm.top+Editor.top+100);
HelpAtCursor(26); //Afficher l'aide de VAR
Editor.SelAttributes.Color:=COMMENTCOLOR;
Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
Editor.seltext:='(* Dclaration des variables *)'+#13#10;

Editor.SelAttributes.Color:=clblack;
Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
Editor.seltext:='VAR ';

for i:=1 to 3 do
BEGIN
Editor.SelAttributes.Color:=VARCOLOR;
Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
Editor.seltext:='<var'+inttostr(i)+'>';

Editor.SelAttributes.Color:=clblack;
Editor.SelAttributes.Style:=CurrText.Style-[fsbold]-[fsitalic]-[fsunderline];
Editor.seltext:=', ';
END;

Editor.SelAttributes.Color:=VARCOLOR;
Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
Editor.seltext:='<...>';

Editor.SelAttributes.Color:=clblack;
Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
Editor.seltext:=' : ';

Editor.SelAttributes.Color:=clblack;
Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
Editor.seltext:='<type de variable>'+#13#10#10;
end;

procedure TMainForm.SpeedButton1Click(Sender: TObject);
begin
CurrText.Name:='Lucida Console';
GetCaretPos(movemouse);
SetCursorPos(movemouse.X+MainForm.Left+Editor.left+8,movemouse.Y+MainForm.top+Editor.top+100);
HelpAtCursor(30);

Editor.SelAttributes.Color:=clblack;
Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
Editor.seltext:='Saisir ';

Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
Editor.SelAttributes.Color:=VARCOLOR;
Editor.seltext:=' ';
Editor.SelStart:=Editor.SelStart-1;
Editor.sellength:=1;
end;

procedure TMainForm.SpeedButton10Click(Sender: TObject);
var i : integer;
begin
CurrText.Name:='Lucida Console';
Editor.SelAttributes.Color:=COMMENTCOLOR;
Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
Editor.seltext:='(* Dclaration des constantes *)'+#13#10;

Editor.SelAttributes.Color:=clblack;
Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
Editor.seltext:='CONST ';

for i:=1 to 3 do
BEGIN
Editor.SelAttributes.Color:=VARCOLOR;
Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
Editor.seltext:='<var'+inttostr(i)+'>';

Editor.SelAttributes.Color:=clblack;
Editor.SelAttributes.Style:=CurrText.Style-[fsbold]-[fsitalic]-[fsunderline];
Editor.seltext:=', ';
END;

Editor.SelAttributes.Color:=VARCOLOR;
Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
Editor.seltext:='<...>';

Editor.SelAttributes.Color:=clblack;
Editor.SelAttributes.Style:=CurrText.Style-[fsbold]-[fsitalic]-[fsunderline];
Editor.seltext:=' '+#13#10#10;
end;
procedure TMainForm.SpeedButton13MouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
Label2.Caption:='gal ...'
end;

procedure TMainForm.Panel1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
Memo1.Clear;
Label2.Caption:='';
end;

procedure TMainForm.SpeedButton14MouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
Label2.Caption:='Diffrent de...'
end;

procedure TMainForm.SpeedButton15MouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
Label2.Caption:='Strictement infrieur ...'
end;

procedure TMainForm.SpeedButton16MouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
Label2.Caption:='Infrieur ou gal ...'
end;

procedure TMainForm.SpeedButton17Click(Sender: TObject);
begin
Label2.Caption:='Strictement suprieur ...'
end;

procedure TMainForm.SpeedButton18MouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
Label2.Caption:='Suprieur ou gal ...'
end;

procedure TMainForm.SpeedButton17MouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
Label2.Caption:='Strictement suprieur ...'
end;

procedure TMainForm.SpeedButton13Click(Sender: TObject);
begin
CurrText.Name:='Lucida Console';
Editor.SelAttributes.Color:=clblack;
Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
Editor.seltext:=(sender as TSpeedButton).Caption+' ';
Editor.SelStart:=Editor.SelStart-1;
Editor.SelLength:=1;
end;

procedure TMainForm.SpeedButton5Click(Sender: TObject);
begin
CurrText.Name:='Lucida Console';
GetCaretPos(movemouse);
SetCursorPos(movemouse.X+MainForm.Left+Editor.left+8,movemouse.Y+MainForm.top+Editor.top+100);
HelpAtCursor(25); //Afficher l'aide de VAR

Editor.SelAttributes.Color:=clblack;
Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
Editor.seltext:='TANTQUE (';

Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
Editor.SelAttributes.Color:=VARCOLOR;
Editor.seltext:='  ';
Editor.SelText:='';

Editor.SelAttributes.Color:=clblack;
Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
Editor.seltext:=' )';

Editor.SelAttributes.Color:=clblack;
Editor.SelAttributes.Style:=CurrText.Style-[fsbold]-[fsitalic]-[fsunderline];
Editor.seltext:=#13#10;
Editor.Paragraph.FirstIndent:=Editor.Paragraph.FirstIndent+10;

Editor.SelAttributes.Color:=clblack;
Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
Editor.seltext:=#13#10+'FINTANTQUE';
Editor.Paragraph.FirstIndent:=Editor.Paragraph.FirstIndent-10;
editor.SelStart:=editor.SelStart-17;
editor.SelLength:=1;


end;

procedure TMainForm.SpeedButton12Click(Sender: TObject);
begin
CurrText.Name:='Lucida Console';
GetCaretPos(movemouse);
SetCursorPos(movemouse.X+MainForm.Left+Editor.left+8,movemouse.Y+MainForm.top+Editor.top+100);
HelpAtCursor(31);
Editor.SelAttributes.Color:=clblack;
Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
Editor.seltext:='Imprimer ';

Editor.SelAttributes.Style:=CurrText.Style-[fsbold]-[fsitalic]-[fsunderline];
Editor.SelAttributes.Color:=STRINGCOLOR;
Editor.seltext:='" "';
editor.SelStart:=editor.SelStart-2;
editor.SelLength:=1;
end;

procedure TMainForm.SpeedButton8Click(Sender: TObject);
begin
CurrText.Name:='Lucida Console';
GetCaretPos(movemouse);
SetCursorPos(movemouse.X+MainForm.Left+Editor.left+8,movemouse.Y+MainForm.top+Editor.top+100);
HelpAtCursor(23); //Afficher l'aide de VAR

Editor.SelAttributes.Color:=clblack;
Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
Editor.seltext:='SI (';

Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
Editor.SelAttributes.Color:=VARCOLOR;
Editor.seltext:='  ';
Editor.SelText:='';

Editor.SelAttributes.Color:=clblack;
Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
Editor.seltext:=' )';

Editor.SelAttributes.Color:=clblack;
Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
Editor.seltext:=#13#10+'ALORS';
Editor.Paragraph.FirstIndent:=Editor.Paragraph.FirstIndent+10;

Editor.SelAttributes.Color:=clblack;
Editor.SelAttributes.Style:=CurrText.Style-[fsbold]-[fsitalic]-[fsunderline];
Editor.seltext:=#13#10;
Editor.Paragraph.FirstIndent:=Editor.Paragraph.FirstIndent+10;

Editor.SelAttributes.Color:=clblack;
Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
Editor.seltext:=#13#10+'SINON';
Editor.Paragraph.FirstIndent:=Editor.Paragraph.FirstIndent-10;

Editor.SelAttributes.Color:=clblack;
Editor.SelAttributes.Style:=CurrText.Style-[fsbold]-[fsitalic]-[fsunderline];
Editor.seltext:=#13#10;
Editor.Paragraph.FirstIndent:=Editor.Paragraph.FirstIndent+10;

Editor.SelAttributes.Color:=clblack;
Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
Editor.seltext:=#13#10+'FINSI';
Editor.Paragraph.FirstIndent:=Editor.Paragraph.FirstIndent-20;
editor.SelStart:=editor.SelStart-28;
editor.SelLength:=1;
end;

procedure TMainForm.SpeedButton7Click(Sender: TObject);
begin
CurrText.Name:='Lucida Console';
GetCaretPos(movemouse);
SetCursorPos(movemouse.X+MainForm.Left+Editor.left+8,movemouse.Y+MainForm.top+Editor.top+100);
HelpAtCursor(230); //Afficher l'aide de VAR

Editor.SelAttributes.Color:=clblack;
Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
Editor.seltext:='SI (';

Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
Editor.SelAttributes.Color:=VARCOLOR;
Editor.seltext:='  ';
Editor.SelText:='';

Editor.SelAttributes.Color:=clblack;
Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
Editor.seltext:=' )';

Editor.SelAttributes.Color:=clblack;
Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
Editor.seltext:=#13#10+'ALORS';
Editor.Paragraph.FirstIndent:=Editor.Paragraph.FirstIndent+10;

Editor.SelAttributes.Color:=clblack;
Editor.SelAttributes.Style:=CurrText.Style-[fsbold]-[fsitalic]-[fsunderline];
Editor.seltext:=#13#10;
Editor.Paragraph.FirstIndent:=Editor.Paragraph.FirstIndent+10;

Editor.SelAttributes.Color:=clblack;
Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
Editor.seltext:=#13#10+'FINSI';
Editor.Paragraph.FirstIndent:=Editor.Paragraph.FirstIndent-20;
editor.SelStart:=editor.SelStart-19;
editor.SelLength:=1;
end;

procedure TMainForm.SpeedButton4Click(Sender: TObject);
begin
CurrText.Name:='Lucida Console';
GetCaretPos(movemouse);
SetCursorPos(movemouse.X+MainForm.Left+Editor.left+8,movemouse.Y+MainForm.top+Editor.top+100);
HelpAtCursor(24); //Afficher l'aide de VAR

Editor.SelAttributes.Color:=clblack;
Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
Editor.seltext:='SUIVANT ';

Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
Editor.SelAttributes.Color:=VARCOLOR;
Editor.seltext:=' ';
Editor.SelText:='';

Editor.SelAttributes.Color:=clblack;
Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
Editor.seltext:=' FAIRE';
Editor.SelAttributes.Color:=clblack;
Editor.SelAttributes.Style:=CurrText.Style-[fsbold]-[fsitalic]-[fsunderline];
Editor.seltext:=#13#10+'1 : ';
Editor.Paragraph.FirstIndent:=Editor.Paragraph.FirstIndent+10;
Editor.seltext:=#13#10+'2 : ';
Editor.seltext:=#13#10+'3 : ';


Editor.SelAttributes.Color:=clblack;
Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
Editor.seltext:=#13#10+'FINSUIVANT';
Editor.Paragraph.FirstIndent:=Editor.Paragraph.FirstIndent-20;

editor.SelStart:=editor.SelStart-37;
editor.SelLength:=1;
end;

procedure TMainForm.Button1Click(Sender: TObject);
var Gpoint : TPoint;
begin
CurrText.Name:='Lucida Console';
GetCaretPos(movemouse);
SetCursorPos(movemouse.X+MainForm.Left+Editor.left+8,movemouse.Y+MainForm.top+Editor.top+100);
HelpAtCursor(27); //Afficher l'aide de VAR

GetCaretPos(Gpoint);
Gpoint.X:=Gpoint.X-5;
Gpoint.Y:=Gpoint.Y-5;
Editor.SetFocus;

Editor.SelAttributes.Color:=clblack;
Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
Editor.seltext:='DBUT';

Editor.SelAttributes.Color:=clblack;
Editor.SelAttributes.Style:=CurrText.Style-[fsbold]-[fsitalic]-[fsunderline];
Editor.seltext:=#13#10+' ';
Editor.Paragraph.FirstIndent:=round(Gpoint.X/1.33)+10;

Editor.SelAttributes.Color:=clblack;
Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
Editor.seltext:=#13#10+'FIN';
Editor.Paragraph.FirstIndent:=Editor.Paragraph.FirstIndent-10;
editor.SelStart:=editor.SelStart-6;
editor.SelLength:=1;
end;

procedure TMainForm.SpeedButton3Click(Sender: TObject);
begin
CurrText.Name:='Lucida Console';
GetCaretPos(movemouse);
SetCursorPos(movemouse.X+MainForm.Left+Editor.left+8,movemouse.Y+MainForm.top+Editor.top+100);
HelpAtCursor(1); //Afficher l'aide de VAR

Editor.SelAttributes.Color:=clblack;
Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
Editor.seltext:='POUR ';

Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
Editor.SelAttributes.Color:=VARCOLOR;
Editor.seltext:=' ';
Editor.SelText:='';

SpeedButton11.Click;

Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
Editor.SelAttributes.Color:=VARCOLOR;
Editor.seltext:=' ';
Editor.SelText:='';

Editor.SelAttributes.Color:=clblack;
Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
Editor.seltext:=' JQA ';

Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
Editor.SelAttributes.Color:=VARCOLOR;
Editor.seltext:=' ';
Editor.SelText:='';

Editor.SelAttributes.Color:=clblack;
Editor.SelAttributes.Style:=CurrText.Style-[fsbold]-[fsitalic]-[fsunderline];
Editor.seltext:=#13#10;
Editor.Paragraph.FirstIndent:=Editor.Paragraph.FirstIndent+10;

Editor.SelAttributes.Color:=clblack;
Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
Editor.seltext:=#13#10+'FPOUR';
Editor.Paragraph.FirstIndent:=Editor.Paragraph.FirstIndent-10;
editor.SelStart:=editor.SelStart-20;
editor.SelLength:=1;
end;

procedure TMainForm.Timer2Timer(Sender: TObject);
begin
Timer2.Enabled:=false;
messagebeep(0);
begin
  with TSplash.Create(Self) do
  try
    ShowModal;
  finally
    Free;
  end;
end;
end;

procedure TMainForm.Apropos1Click(Sender: TObject);
begin
Timer2.Enabled:=true;
end;

procedure TMainForm.Button2Click(Sender: TObject);
var backuppos : Tpoint;
begin
CurrText.Name:='Lucida Console';
with Tfonc.Create(Self) do
try
  ShowModal;
finally
  Free;
end;

if fonction<>'' then
BEGIN
Editor.SetFocus;
Editor.SelAttributes.Color:=clblack;
Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]+[fsunderline];
Editor.seltext:=fonction;
GetCaretPos(backuppos);
Editor.SelAttributes.Color:=clblack;
Editor.SelAttributes.Style:=CurrText.Style-[fsbold]-[fsitalic]-[fsunderline];
Editor.SelText:=' ';
Editor.SelStart:=length(Editor.text);
Editor.SelAttributes.Color:=COMMENTCOLOR;
Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
editor.SelText:=#13#10#10+'//////////////////////////////////////////////////////////////////////';
Editor.SelAttributes.Color:=clBlack;
Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
editor.SelText:=#13#10+fonction;

if param1<>'' then
BEGIN
Editor.SelAttributes.Color:=clBlack;
Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
editor.SelText:='(';
Editor.SelAttributes.Color:=VARCOLOR;
Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
editor.SelText:=param1;
    if param2<>'' then
    BEGIN
     Editor.SelAttributes.Color:=clBlack;
     Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
     editor.SelText:=',';
     Editor.SelAttributes.Color:=VARCOLOR;
     Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
     Editor.SelText:=param2;
           if param3<>'' then
           BEGIN
             Editor.SelAttributes.Color:=clBlack;
             Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
             Editor.SelText:=',';
             Editor.SelAttributes.Color:=VARCOLOR;
             Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
             Editor.SelText:=param3;
             Editor.SelAttributes.Color:=clBlack;
             Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
             Editor.SelText:=')';
           END
           ELSE
           BEGIN
           Editor.SelAttributes.Color:=clBlack;
           Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
           Editor.SelText:=')';
           END;
    END
    ELSE
    BEGIN
Editor.SelAttributes.Color:=clBlack;
Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
editor.SelText:=')';
    END;
END;



Editor.SelAttributes.Color:=COMMENTCOLOR;
Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
if comment<>'' then editor.SelText:=' (* '+comment+' *)' else editor.SelText:=' (* Procedure '+fonction+' *)';
Editor.SelAttributes.Color:=COMMENTCOLOR;
Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
editor.SelText:=#13#10;
Editor.SelAttributes.Color:=clblack;
Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
Editor.seltext:='DBUT';
Editor.SelAttributes.Color:=clblack;
Editor.SelAttributes.Style:=CurrText.Style-[fsbold]-[fsitalic]-[fsunderline];
Editor.seltext:=#13#10;
Editor.Paragraph.FirstIndent:=Editor.Paragraph.FirstIndent+10;
Editor.SelAttributes.Color:=clblack;
Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
Editor.seltext:=#13#10+'FIN';
Editor.Paragraph.FirstIndent:=Editor.Paragraph.FirstIndent-10;
SetCaretPos(backuppos.X,backuppos.Y)
END;

end;

procedure TMainForm.Slctionnertout1Click(Sender: TObject);
begin
Editor.SelectAll;
end;

procedure TMainForm.fontcolorClick(Sender: TObject);
begin
ColorDialog1.color:=fontcolor.Color;
if ColorDialog1.Execute then
BEGIN
editor.SelAttributes.Color:=ColorDialog1.color;
fontcolor.color:=ColorDialog1.color;
END;
end;

procedure TMainForm.Coloration1Click(Sender: TObject);
begin
  with Tcolora.Create(Self) do
  try
    ShowModal;
  finally
    Free;
  end;
end;

procedure TMainForm.EditorKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var word,tmp1,tmp2:string;
       i,j:integer;
LineNum, charsBeforeLine:longint;

begin
IF ((key=VK_RETURN) and (Findeligneauto1.Checked=true)) then
BEGIN
 LineNum:=SendMessage(Editor.Handle,EM_LINEFROMCHAR,Editor.SelStart,0);
 CharsBeforeLine:=SendMessage(Editor.Handle,EM_LINEINDEX,LineNum,0);
 Editor.SelStart:=CharsBeforeLine+length(Editor.Lines[LineNum]);
 Editor.SelAttributes.Color:=ClBlack;
 Editor.SelAttributes.Style:=CurrText.Style-[fsbold]-[fsitalic]-[fsunderline];
exit;
END;   



IF Length(Editor.Text)=0 then
BEGIN
   if ((Ord(Key)>=96) and (ord(Key)<=105))=true then                               //si c un chiffre,
   BEGIN
   Editor.SelAttributes.Color:=NUMCOLOR;                                           //on l'ecris en bleu
   Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
   END;
   if Ord(Key)=51 then                                                             //si c une chaine de caracteres
   BEGIN
   Editor.SelAttributes.Color:=STRINGCOLOR;                                        //on l'ecris en bleu fonc
   Editor.SelAttributes.Style:=CurrText.Style-[fsbold]-[fsitalic]-[fsunderline];
   END;
EXIT;                                                                              //ensuite, on ferme tout !
END;      

if fontcolor.Color=COMMENTCOLOR then exit;                                       //Si c'est un commentaire, on sort...

if fontcolor.Color=STRINGCOLOR then                                              //Si on est dans une chaine de cara
BEGIN                                                                            //qui n'est pas termine (") alors,
if Editor.Text[Editor.SelStart]<>'"' then exit;                                  //on ne formate rien !
END;  

if ((Ord(Key)>=96) and (ord(Key)<=105))=true then                                //Si on tape un chiffre, et que ca
  BEGIN                                                                          //n'est pas a l'interieur d'une chaine
    if (fontcolor.Color<>STRINGCOLOR) then                                       //de caractere, d'une variable, ou
    BEGIN                                                                        //d'un commentraire, alors ...
       if (fontcolor.Color<>VARCOLOR) then
       BEGIN
           Editor.SelAttributes.Color:=NUMCOLOR;                                           //on l'ecris en bleu
           Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline]; //et en gras
       END;
    END;
  END
ELSE                                                                             //sinon, si le caractere precedant est
 BEGIN                                                                           //bleu, alors,
 if fontcolor.Color=NUMCOLOR then
   BEGIN                                                                         //on demande d'crire
   Editor.SelAttributes.Color:=clBlack;                                          //en noir
   Editor.SelAttributes.Style:=CurrText.Style-[fsbold]-[fsitalic]-[fsunderline]; //et sans gras !
   END
   ELSE
   BEGIN
         if (Editor.Text[Editor.SelStart]=',') then                              //on cherche une virgule avant !
      BEGIN
        Editor.SelAttributes.Color:=VARCOLOR;                                        //si trouv, on met en rouge
        Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];//ce qui suit la virgule
      END;

      if Editor.Text[Editor.SelStart]='=' then                                       //on cherche un egal avant !
      BEGIN
        Editor.SelAttributes.Color:=VARCOLOR;                                        //si trouv, on met en rouge
        Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];//ce qui suit la virgule
      END;

      if Editor.Text[Editor.SelStart]='<' then                                       //on cherche un egal avant !
      BEGIN
        Editor.SelAttributes.Color:=VARCOLOR;                                        //si trouv, on met en rouge
        Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];//ce qui suit la virgule
      END;

      if Editor.Text[Editor.SelStart]=')' then                                       //on cherche un ) avant !
      BEGIN
        Editor.SelAttributes.Color:=clblack;                                         //si trouv, on met en rouge
        Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];//ce qui suit la virgule
      END;

      if Editor.Text[Editor.SelStart]='(' then                                       //on cherche un ( avant !
      BEGIN
        Editor.SelAttributes.Color:=VARCOLOR;                                        //si trouv, on met en rouge
        Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];//ce qui suit la virgule
      END;

      if Editor.Text[Editor.SelStart]='>' then                                       //on cherche un egal avant !
      BEGIN
        Editor.SelAttributes.Color:=VARCOLOR;                                        //si trouv, on met en rouge
        Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];//ce qui suit la virgule
      END;
   END;
 END;

if Ord(Key)=51 then                                                             //Quand on tape un ", c une chaine
  BEGIN                                                                         //de caractere...
  Editor.SelAttributes.Color:=STRINGCOLOR;                                      //on met en bleu navy
  Editor.SelAttributes.Style:=CurrText.Style-[fsbold]-[fsitalic]-[fsunderline];
  END;

if Ord(Key)=188 then
  BEGIN                                                                          //Quand on tape une virgule                                                                        //de caractere...
  Editor.SelAttributes.Color:=clBlack;                                           //on l'a met en noir
  Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
  END;

if Ord(Key)=191 then                                                             //Quand on tape un deux-points
  BEGIN                                                                          //de caractere...
  Editor.SelAttributes.Color:=clBlack;                                           //on les mets en noir
  Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
  END;

if ord(Key)=187 then                                                             //Quand on tape un egal
  BEGIN                                                                          //on le met en noir
  Editor.SelAttributes.Color:=clblack;
  Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
  END;

if ord(Key)=226 then                                                             //Quand on tape un < ou >
  BEGIN                                                                          //on le met en noir
  Editor.SelAttributes.Color:=clblack;
  Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
  END;

if ord(Key)=53 then                                                             //Quand on tape un (
  BEGIN                                                                         //on le met en noir
  Editor.SelAttributes.Color:=clblack;
  Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
  END;

if ord(Key)=219 then                                                             //Quand on tape un )
  BEGIN                                                                          //on le met en noir
  Editor.SelAttributes.Color:=clblack;
  Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
  END;

for j:=0 to keyword.Count-1 do                                                   //test des mots cls
BEGIN                                                                            //si on en trouve un
word:=keyword.Strings[j];                                                        //alors on l'ecris en
tmp1:='';                                                                        //noir et en gras
for i:=length(word)-1 downto 0 do                                                //puis on met le rouge
BEGIN                                                                            //pour car il risque
tmp1:=tmp1+upcase(Editor.Text[Editor.selstart-i]);                               //d'y avoir une variable
END;                                                                             //ensuite !

if tmp1=Word then
BEGIN
  Editor.SelStart:=Editor.SelStart-length(word);
  Editor.SelLength:=length(word);
  Editor.Seltext:=tmp1;
  Editor.SelStart:=Editor.SelStart-length(word);
  Editor.SelLength:=length(word);
  Editor.SelAttributes.Color:=clBlack;
  Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
  Editor.SelStart:=Editor.SelStart+length(word);
  Editor.SelAttributes.Color:=clred;
  Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
END;
end;


end;

procedure TMainForm.SpeedButton9MouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
var   aide : Tinifile;
begin
memo1.clear;
aide:=TIniFile.Create(AppDir+'aide.ini');
memo1.lines[0]:=aide.ReadString('infobulle',(Sender as TSpeedButton).Hint,'');
aide.Free;
end;

procedure TMainForm.Memo1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
memo1.SetFocus;
SetCaretPos(-10,-10);
Editor.SetFocus;
end;

procedure TMainForm.Afficherlaide1Click(Sender: TObject);
var regi : Tregistry;
begin
if Afficherlaide1.Checked then
BEGIN
regi:=TRegistry.Create;
regi.RootKey:=HKEY_LOCAL_MACHINE;
regi.OpenKey('Software\MOATI\WriteAlgo',true);
regi.WriteString('ENABLEHELP','false');
panel2.Visible:=false;
regi.CloseKey;
regi.Free;
Afficherlaide1.Checked:=false;
END
ELSE
BEGIN
regi:=TRegistry.Create;
regi.RootKey:=HKEY_LOCAL_MACHINE;
regi.OpenKey('Software\MOATI\WriteAlgo',true);
regi.WriteString('ENABLEHELP','true');
panel2.Visible:=true;
regi.CloseKey;
regi.Free;
Afficherlaide1.Checked:=true;
END;
end;

procedure TMainForm.Timer3Timer(Sender: TObject);
var confirm : integer;
begin
Timer3.Enabled:=false;
SetModified(false);
begin
  with TSplash.Create(Self) do
  try
    ShowModal;
  finally
    Free;
  end;
end;
with Tnouveau.Create(Self) do
try
  confirm:=ShowModal;
finally
  Free;
end;
if confirm=mrok then
BEGIN
  SetFileName(sUntitled);
  Editor.Lines.Clear;
  Timer1.Enabled:=true;
  Editor.Modified := False;
  SetModified(False);
END;
end;

procedure TMainForm.Findeligneauto1Click(Sender: TObject);
var regi : Tregistry;
begin
if Findeligneauto1.Checked then
BEGIN
regi:=TRegistry.Create;
regi.RootKey:=HKEY_LOCAL_MACHINE;
regi.OpenKey('Software\MOATI\WriteAlgo',true);
regi.WriteString('ENDOFLINEAUTO','false');
regi.CloseKey;
regi.Free;
Findeligneauto1.Checked:=false;
END
ELSE
BEGIN
regi:=TRegistry.Create;
regi.RootKey:=HKEY_LOCAL_MACHINE;
regi.OpenKey('Software\MOATI\WriteAlgo',true);
regi.WriteString('ENDOFLINEAUTO','true');
regi.CloseKey;
regi.Free;
Findeligneauto1.Checked:=true;
END;
end;

procedure TMainForm.EditorKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var i: integer;
begin
memo1.Text:=WordAtCursor;
if fontcolor.color=COMMENTCOLOR then
BEGIN
  memo1.Clear;
  memo1.SelAttributes.Color:=COMMENTCOLOR;
  memo1.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
  memo1.seltext:='Commentaire : '+#13#10+'(* Commentaire sur plusieurs lignes *)'+#13#10+'// Commentaire sur une ligne';
exit;
END;
  for i:=0 to keywords.Count-1 do
  BEGIN
    if memo1.FindText(keywords.Strings[i],0,length(memo1.Text),[])<>-1 then
    BEGIN
    HelpAtCursor(i);
    EXIT;
   END;
  END;
if memo1.Text=WordAtCursor then memo1.Clear;
end;

procedure TMainForm.EditorMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var i : integer;
begin
memo1.Text:=WordAtCursor;
if fontcolor.color=COMMENTCOLOR then
BEGIN
  memo1.Clear;
  memo1.SelAttributes.Color:=COMMENTCOLOR;
  memo1.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
  memo1.seltext:='Commentaire : '+#13#10+'(* Commentaire sur plusieurs lignes *)'+#13#10+'// Commentaire sur une ligne';
exit;
END;
  for i:=0 to keywords.Count-1 do
  BEGIN
    if memo1.FindText(keywords.Strings[i],0,length(memo1.Text),[])<>-1 then
    BEGIN
    HelpAtCursor(i);
    EXIT;
   END;
  END;
if memo1.Text=WordAtCursor then memo1.Clear;
end;

procedure TMainForm.SpeedButton21Click(Sender: TObject);
begin
CurrText.Name:='Lucida Console';
GetCaretPos(movemouse);
SetCursorPos(movemouse.X+MainForm.Left+Editor.left+8,movemouse.Y+MainForm.top+Editor.top+100);
HelpAtCursor(0); //Afficher l'aide de VAR

Editor.SelAttributes.Color:=clblack;
Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
Editor.seltext:='REPETER'+#13#10;;

Editor.Paragraph.FirstIndent:=Editor.Paragraph.FirstIndent+10;
Editor.SelAttributes.Color:=clblack;
Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
Editor.seltext:=' '+#13#10;

Editor.SelAttributes.Color:=clblack;
Editor.SelAttributes.Style:=CurrText.Style+[fsbold]-[fsitalic]-[fsunderline];
Editor.seltext:='JUSQU''A';

Editor.SelAttributes.Color:=clblack;
Editor.SelAttributes.Style:=CurrText.Style-[fsbold]-[fsitalic]-[fsunderline];
Editor.seltext:=' <Condition>';

Editor.Paragraph.FirstIndent:=Editor.Paragraph.FirstIndent-10;
editor.SelStart:=editor.SelStart-22;
editor.SelLength:=1;
end;

end.


//La fonction que j'utilise, Ord(Key)=191, ne test que le code cl de la touche presse...
//Ainsi, les caracteres '?' et ',' ont le mme code touche, d'ou une reaction similaire !!!
//Ce n'est pas grave dans la mesure ou on n'utilise pas ce genre de caractere ailleurs que
//dans des commentaire, ou texte (donc, il sont protgs)...
//Pour faire un truc super propre, il faudrais quand mme vrifi l'etat de la touche MAJ
//pour detecter le bon caractere :)
//
//Du coup, seul les touches du pav numerique ne fonctionnent pour avoir des chiffres en bleu !
