unit config;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, registry;

type
  Tcolora = class(TForm)
    Label2: TLabel;
    Bevel1: TBevel;
    Panel1: TPanel;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    Label1: TLabel;
    Label3: TLabel;
    Panel2: TPanel;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    CheckBox6: TCheckBox;
    Label4: TLabel;
    Panel3: TPanel;
    CheckBox7: TCheckBox;
    CheckBox8: TCheckBox;
    CheckBox9: TCheckBox;
    Label5: TLabel;
    Panel4: TPanel;
    CheckBox10: TCheckBox;
    CheckBox11: TCheckBox;
    CheckBox12: TCheckBox;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Label6: TLabel;
    Panel5: TPanel;
    CheckBox13: TCheckBox;
    CheckBox14: TCheckBox;
    CheckBox15: TCheckBox;
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Panel1Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  colora: Tcolora;

implementation

{$R *.dfm}

uses remain;

procedure Tcolora.Button2Click(Sender: TObject);
begin
close;
end;

procedure Tcolora.Button1Click(Sender: TObject);
var regi : TRegistry;
begin
  regi:=TRegistry.Create;
  regi.RootKey:=HKEY_LOCAL_MACHINE;
  regi.OpenKey('Software\MOATI\WriteAlgo',true);
  COMMENTCOLOR :=Panel1.Color;
  STRINGCOLOR  :=Panel2.Color;
  VARCOLOR     :=Panel3.Color;
  KEYWORDCOLOR :=Panel4.Color;
  NUMCOLOR     :=Panel5.Color;

  regi.WriteString('COMMENTCOLOR', ColorToString(Panel1.Color));
  regi.WriteString('STRINGCOLOR',  ColorToString(Panel2.Color));
  regi.WriteString('VARCOLOR',     ColorToString(Panel3.Color));
  regi.WriteString('KEYWORDCOLOR', ColorToString(Panel4.Color));
  regi.WriteString('NUMCOLOR',     ColorToString(Panel5.Color));

close;
end;

procedure Tcolora.Button3Click(Sender: TObject);
begin
Panel1.Color:=clTeal;
Panel2.Color:=clNavy;
Panel3.Color:=clred;
panel4.Color:=clBlack;
panel5.Color:=clBlue;
CheckBox1.Checked:=true;
CheckBox2.Checked:=false;
CheckBox3.Checked:=false;
CheckBox4.Checked:=false;
CheckBox5.Checked:=false;
CheckBox6.Checked:=false;
CheckBox7.Checked:=true;
CheckBox8.Checked:=false;
CheckBox9.Checked:=false;
CheckBox10.Checked:=true;
CheckBox11.Checked:=false;
CheckBox12.Checked:=false;
CheckBox13.Checked:=true;
CheckBox14.Checked:=false;
CheckBox15.Checked:=false;
end;

procedure Tcolora.FormCreate(Sender: TObject);
begin
Panel1.Color:=COMMENTCOLOR;
Panel2.Color:=STRINGCOLOR;
Panel3.Color:=VARCOLOR;
Panel4.Color:=KEYWORDCOLOR;
Panel5.Color:=NUMCOLOR;
end;

procedure Tcolora.Panel1Click(Sender: TObject);
begin
MainForm.ColorDialog1.Color:=(Sender as Tpanel).Color;
if MainForm.ColorDialog1.Execute then (Sender as Tpanel).Color:=MainForm.ColorDialog1.Color;
end;

end.
